﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Text;

namespace Orxe2Setup
{
    public class FileHandlingOfGruntFileJs
    {
        public string Path { get; set; }

        public FileHandlingOfGruntFileJs(string pathOfGruntFileJS, string branchNumber)
        {
            //C:\Vicky\Connexions\AppDev\Code\ORXe\201909\ORXe2.0\02. UI\Portal\Build\Grunt.targets
            this.Path = @pathOfGruntFileJS + @"\AppDev\Code\ORXe\" + branchNumber + @"\ORXe2.0\Grunt\Gruntfile.js";
        }

        public void HandleFile()
        {
            Console.WriteLine("File Present - " + File.Exists(this.Path));
            if (File.Exists(this.Path))
            {
                FileInfo fileInfo = new FileInfo(this.Path);
                fileInfo.IsReadOnly = false;
                try
                {
                    Console.WriteLine("Making required changes in GruntFile.js file. Please wait...");
                    string[] lines = File.ReadAllLines(this.Path);
                    CopyTheFileAndBlankIt(this.Path);

                    for (var i = 0; i < lines.Length; i++)
                    {
                        if (lines[i].ToLower().Contains("'autoprefixer',"))
                        {
                            lines[i] = String.Concat(lines[i].Split("'autoprefixer',"));
                            WriteToFile(lines[i]);

                        } else { 
                            WriteToFile(lines[i]);
                        }
                    }
                    Console.WriteLine("Rewriting Done!!!");

                    File.Delete(this.Path + "_TEMP");

                }
                catch (Exception e)
                {
                    File.Delete(this.Path);
                    File.Copy(this.Path + "_TEMP", this.Path);
                    File.Delete(this.Path + "_TEMP");
                    throw e;
                }
            }
            else
            {
                Console.WriteLine("Error: File not found. please enter correct path.!!!");
                Console.ReadLine();
            }



        }
        public void WriteToFile(string line)
        {
            using (StreamWriter sw = File.AppendText(this.Path))
            {
                sw.WriteLine(line);
            }
        }
        public void CopyTheFileAndBlankIt(string filePath)
        {

            File.Copy(filePath, filePath + "_TEMP");
            File.WriteAllText(filePath, "");

        }
    }
}
