﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Xml.Serialization;

namespace Orxe2Setup
{
    public class FileHandlingOfGruntTargets
    {
        public string Path { get; set; }

        public FileHandlingOfGruntTargets(string pathOfGruntFile,string branchNumber)
        {
            //C:\Vicky\Connexions\AppDev\Code\ORXe\201909\ORXe2.0\02. UI\Portal\Build\Grunt.targets
            this.Path = @pathOfGruntFile + @"\AppDev\Code\ORXe\"+ branchNumber + @"\ORXe2.0\02. UI\Portal\Build\Grunt.targets";
        }

        public void HandleFile() {
            Boolean isTargetOpenTag = false;
            Console.WriteLine("File Present - " + File.Exists(this.Path));
            if (File.Exists(this.Path))
            {
                FileInfo fileInfo = new FileInfo(this.Path);
                fileInfo.IsReadOnly = false;
                try
                {
                    Console.WriteLine("Making required changes in Grunt.target file. Please wait...");
                    string[] lines = File.ReadAllLines(this.Path);
                    CopyTheFileAndBlankIt(this.Path);

                    for (var i = 0; i < lines.Length; i++)
                    {
                        if (lines[i].Contains("<Target"))
                        {
                            isTargetOpenTag = true;
                            WriteToFile(lines[i]);

                        }
                        else if (lines[i].Contains("</Target>") && isTargetOpenTag)
                        {
                            isTargetOpenTag = false;
                            WriteToFile(lines[i]);
                        }
                        else if (!isTargetOpenTag)
                        {
                            WriteToFile(lines[i]);
                        }
                    }
                    Console.WriteLine("Rewriting Done!!!");

                    File.Delete(this.Path + "_TEMP");
                }
                catch (Exception e)
                {
                    File.Delete(this.Path);
                    File.Copy(this.Path + "_TEMP", this.Path);
                    File.Delete(this.Path + "_TEMP");
                    throw e;
                }
            }
            else {
                Console.WriteLine("Error: File not found. please enter correct path.!!!");
                Console.ReadLine();
            }

           
            
        }
        public void WriteToFile(string line)
        {
            using (StreamWriter sw = File.AppendText(this.Path))
            {
                sw.WriteLine(line);
            }
        }
        public void CopyTheFileAndBlankIt(string filePath)
        {

            File.Copy(filePath, filePath + "_TEMP");
            File.WriteAllText(filePath, "");

        }

    }
}
