﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Xml.Serialization;

namespace Orxe2Setup
{
    public class FileHandlingOfSSOWebConfig
    {
        public string Path { get; set; }
        public string PortNumber { get; set;}
        public FileHandlingOfSSOWebConfig(string basePathOfFile,string portNumber)
        {
            //C:\Vicky\Connexions\AppDev\Code\Standalone\SSO Simulator\SSO Simulator\Web.Config
            this.Path = basePathOfFile + @"\AppDev\Code\Standalone\SSO Simulator\SSO Simulator\Web.Config";
            this.PortNumber = portNumber;
        }

        public void HandleFile()
        {
            Console.WriteLine("File Present - " + File.Exists(this.Path));

            if (File.Exists(this.Path))
            {
                FileInfo fileInfo = new FileInfo(this.Path);
                fileInfo.IsReadOnly = false;
                try
                {
                    Boolean isAppSettingOpen = false;
                    Console.WriteLine("Making required changes in SSO Web.Config file. Please wait...");
                    string[] lines = File.ReadAllLines(this.Path);
                    CopyTheFileAndBlankIt(this.Path);

                    foreach (var line in lines) {

                        if (isAppSettingOpen)
                        {
                            if (line.Trim().Contains("BookingToolBaseUrl"))
                            {
                                string[] arrayofChanginglines = line.Split(" ");
                                arrayofChanginglines[arrayofChanginglines.Length -1] = "value=\"https://localhost:" + this.PortNumber + "/\"/>";
                                WriteToFile(String.Join(" ", arrayofChanginglines));
                            }
                            else {
                                WriteToFile(line);
                            }

                        }
                        else
                        {
                            WriteToFile(line);
                        }

                        if (line.Trim().ToLower().Equals("<appsettings>")) {
                            isAppSettingOpen = true;
                        }

                        if (line.Trim().ToLower().Equals("</appsettings>") && isAppSettingOpen) {
                            isAppSettingOpen = false;
                        }

                    }

                    Console.WriteLine("Rewriting Done!!!");

                    File.Delete(this.Path + "_TEMP");
                }
                catch (Exception e)
                {
                    File.Delete(this.Path);
                    File.Copy(this.Path + "_TEMP", this.Path);
                    File.Delete(this.Path + "_TEMP");
                    throw e;
                }
            }
            else
            {
                Console.WriteLine("Error: File not found. please enter correct path.!!!");
                Console.ReadLine();
            }
        }
        public void WriteToFile(string line)
        {
            using (StreamWriter sw = File.AppendText(this.Path))
            {
                sw.WriteLine(line);
            }
        }
        public void CopyTheFileAndBlankIt(string filePath)
        {

            File.Copy(filePath, filePath + "_TEMP");
            File.WriteAllText(filePath, "");

        }
    }
}
