﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Xml.Serialization;

namespace Orxe2Setup
{
    public class FileHandlingPortalCsproj
    {
        public string Path { get; set; }
        public string LucenePath { get; set; }
        public string EnvironmentToPoint { get; set; }
        public string BranchNumber { get; set; }

        public FileHandlingPortalCsproj(string basePathOfFile, string branchNumber)
        {
            // C:\Vicky\Connexions\AppDev\Code\ORXe\201909\ORXe2.0\02.UI\Portal\
            this.Path = basePathOfFile + @"\AppDev\Code\ORXe\" + branchNumber + @"\ORXe2.0\02. UI\Portal\Portal.csproj.user";
        }

        public void HandleFile()
        {
            Console.WriteLine("Adding File Portal.csproj.user to : "+ this.Path);
            
            if (File.Exists(this.Path))
            {
                FileInfo fileInfo = new FileInfo(this.Path);
                fileInfo.IsReadOnly = false;
                CopyTheFileAndBlankIt(this.Path);
                try
                {
                    string[] lines = File.ReadAllLines(this.Path);
                    
                    Console.WriteLine("Rewriting Done!!!");
                    File.Copy("Portal.csproj.user", this.Path);
                }
                catch (Exception e)
                {
                    File.Delete(this.Path);
                    File.Copy(this.Path +"_TEMP", this.Path);
                    File.Delete(this.Path + "_TEMP");
                    Console.ReadLine();
                    throw e;
                }
            }
            else
            {
                try
                {
                    File.Copy("Portal.csproj.user", this.Path);
                }
                catch (Exception e)
                {
                    Console.WriteLine("Handle it Manually");
                    Console.ReadLine();
                    throw e;
                }
            }
        }
        

        public void WriteToFile(string line)
        {
            using (StreamWriter sw = File.AppendText(this.Path))
            {
                sw.WriteLine(line);
            }
        }

        public void CopyTheFileAndBlankIt(string filePath) {

            File.Copy(filePath, filePath + "_TEMP");
            File.WriteAllText(filePath, "");

        }
    }

}
